#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

typedef struct {
	int start;
	int end;
	int result;
} thread_args;

int sum;

void * runner(void * param);

int main(int argc, char * argv[]) {
pthread_t tid_A;
pthread_attr_t attr_A;
thread_args args_A;

pthread_t tid_B;
pthread_attr_t attr_B;
thread_args args_B;

int n;

	if (argc != 2) {
		fprintf(stderr, "usage: summation <integer>\n");
		exit(1);
	}

	pthread_attr_init(&attr_A);
	pthread_attr_init(&attr_B);

	args_A.start = 1;
	args_A.end = atoi(argv[1])/2;
	pthread_create(&tid_A, &attr_A, runner, &args_A);
	
	args_B.start = 1 + atoi(argv[1])/2;
	args_B.end = atoi(argv[1]);
	pthread_create(&tid_B, &attr_B, runner, &args_B);

	pthread_join(tid_A, NULL);
	pthread_join(tid_B, NULL);

	sum = args_A.result + args_B.result;

	printf("sum = %d\n", sum);

	return(EXIT_SUCCESS);
	
}

void * runner(void * param) {
int i;
thread_args * lparam = (thread_args *) param;
	
	printf("s = %d, e = %d\n", (*lparam).start, (*lparam).end);

	(*lparam).result = 0;
	for (i = (*lparam).start; i<=(*lparam).end; i++) (*lparam).result += i;

	pthread_exit(0);
}
